/*
    This program calls the "thread functions" as threads,
    that is, they are called concurrently. Notice that this
    program has three threads. The main thread blocks on
    pthread_join() in order to wait for the two child threads
    to complete.

    This program passes parameters (by reference) to the threads.
    The pointers to the parameters are on each thread's stack.
    Use a virtual memory mapping program to see where stack threads
    are placed in virtual memeory.
*/
#include <stdio.h>    // fprintf(), stderr
#include <pthread.h>

#define COUNT 1000

// function prototypes
void *thread1(void *vargp);
void *thread2(void *vargp);

int main()
{
   pthread_t tid[2];

   char arg1 = 'x';
   char arg2 = 'y';

   fprintf(stderr, "Address of arg1 = %p\n", &arg1);
   fprintf(stderr, "Address of arg2 = %p\n\n", &arg2);

   // create the threads
   pthread_create(&(tid[0]), NULL, thread1, &arg1);  // should have error checking
   pthread_create(&(tid[1]), NULL, thread2, &arg2);

   // wait for the threads to finish
   pthread_join(tid[0], NULL);
   pthread_join(tid[1], NULL);

   fprintf(stderr, "\nAll done.\n");

   return 0;
}


void *thread1(void *vargp)  // vargp means "variable (length) argument pointer"
{
   char arg = *((char*)vargp); // the "void pointer" needs to be cast back into a char pointer

   for (int i = 0; i < COUNT; ++i)
   {
      printf("%c", arg);
   }

   //while(1) sleep(10);   //use this to pause the thread and look at virtual memory
   fflush(stdout);
   return NULL;
}


void *thread2(void *vargp)
{
   char arg = *((char*)vargp); // the "void pointer" needs to be cast back into a char pointer

   for (int i = 0; i < COUNT; ++i)
   {
      printf("%c", arg);
   }

   //while(1) sleep(10);   //use this to pause the thread and look at virtual memory
   fflush(stdout);
   return NULL;
}
