/*
   This version uses a thread to display the message box. Each display
   thread blocks until the user clicks the "OK" button in its message box.
   But the main thread of the application does not block, so the program's
   user can keep on entering numbers, even while a message box is displayed.
*/
#include <windows.h>
#include <stdio.h>

// thread function prototype
DWORD WINAPI displayMessageBox(LPVOID);

int main()
{
   int number;
   printf("Please enter a number (0 to quit): ");
   scanf("%d", &number);
   while(0 != number)
   {
      // create a thread to display the message box
      CreateThread(NULL, 0, displayMessageBox, &number, 0, NULL);
      printf("Please enter a number (0 to quit): ");
      scanf("%d", &number);
   }
   //ExitThread(0);
   return 0;
}//main()

DWORD WINAPI displayMessageBox(LPVOID threadParam)
{
   int number = *(int*)threadParam;
   char titleText[] = "Here is what you entered";
   char messageText[20];
   sprintf(messageText, "Your number is %d.", number);
   MessageBox(NULL, messageText, titleText, MB_OK | MB_ICONINFORMATION | MB_TOPMOST);
   return 0;
}//displayMessageBox()
