/*
    This program calls the "thread functions" as threads,
    that is, they are called concurrently. Notice that this
    program has three threads. The main thread blocks on
    pthread_join() in order to wait for the two child threads
    to complete.

    Run this program many times. You should see different
    interleavings of the output strings.
*/
#include <stdio.h>    // fprintf(), stderr
#include <pthread.h>

#define COUNT 1000

// function prototypes
void *thread1(void *vargp);
void *thread2(void *vargp);

int main()
{
   pthread_t tid[2];

   // create the threads
   pthread_create(&(tid[0]), NULL, thread1, NULL);  // should have error checking
   pthread_create(&(tid[1]), NULL, thread2, NULL);

   // wait for the threads to finish
   pthread_join(tid[0], NULL);
   pthread_join(tid[1], NULL);

   fprintf(stderr, "\nAll done.\n");

   return 0;
}


void *thread1(void *vargp) // vargp means "variable (length) argument pointer"
{
   for (int i = 0; i < COUNT; ++i)
   {
      printf("a");
   }
   fflush(stdout);
   return NULL;
}


void *thread2(void *vargp)
{
   for (int i = 0; i < COUNT; ++i)
   {
      printf("b");
   }
   fflush(stdout);
   return NULL;
}
